Index: branches/vs-enhencements/src/world_entities/space_ships/space_ship.cc
===================================================================
--- branches/vs-enhencements/src/world_entities/space_ships/space_ship.cc	(revision 10671)
+++ branches/vs-enhencements/src/world_entities/space_ships/space_ship.cc	(revision 10672)
@@ -167,20 +167,20 @@
 //   this->weaponMan.createWeaponSlot(0, 3.270, 1.028, .155, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
 //   this->weaponMan.createWeaponSlot(1, 3.270, 1.028, -.155, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-  this->weaponMan.createWeaponSlot(2, 4.385, .063, .876, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-  this->weaponMan.createWeaponSlot(3, 4.385, -.063, -.876, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-  this->weaponMan.createWeaponSlot(4, 1.635, -.612, 2.691, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-  this->weaponMan.createWeaponSlot(5, 1.536, -.612, -2.691, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-  this->weaponMan.createWeaponSlot(6, 1.536, -.612, 3.254, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-  this->weaponMan.createWeaponSlot(7, 1.536, -.612, -3.254, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-
-
-//   this->weaponMan.addWeaponToSlot(0, 0, "RFCannon");
-//   this->weaponMan.addWeaponToSlot(0, 1, "RFCannon");
-//   this->weaponMan.addWeaponToSlot(0, 2, "RFCannon");
-//   this->weaponMan.addWeaponToSlot(0, 3, "RFCannon");
-//   this->weaponMan.addWeaponToSlot(1, 0, "RFCannon");
-//   this->weaponMan.addWeaponToSlot(1, 1, "RFCannon");
-//   this->weaponMan.addWeaponToSlot(1, 2, "RFCannon");
-//   this->weaponMan.addWeaponToSlot(1, 3, "RFCannon");
+//   this->weaponMan.createWeaponSlot(2, 4.385, .063, .876, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+//   this->weaponMan.createWeaponSlot(3, 4.385, -.063, -.876, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+//   this->weaponMan.createWeaponSlot(4, 1.635, -.612, 2.691, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+//   this->weaponMan.createWeaponSlot(5, 1.536, -.612, -2.691, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+//   this->weaponMan.createWeaponSlot(6, 1.536, -.612, 3.254, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+//   this->weaponMan.createWeaponSlot(7, 1.536, -.612, -3.254, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+
+
+  this->weaponMan.addWeaponToSlot(0, 0, "RFCannon");
+  this->weaponMan.addWeaponToSlot(0, 1, "RFCannon");
+  this->weaponMan.addWeaponToSlot(0, 2, "RFCannon");
+  this->weaponMan.addWeaponToSlot(0, 3, "RFCannon");
+  this->weaponMan.addWeaponToSlot(1, 0, "RFCannon");
+  this->weaponMan.addWeaponToSlot(1, 1, "RFCannon");
+  this->weaponMan.addWeaponToSlot(1, 2, "RFCannon");
+  this->weaponMan.addWeaponToSlot(1, 3, "RFCannon");
 
   this->weaponMan.addWeaponToSlot(0, 4, "NadionLaser");
@@ -211,8 +211,4 @@
   Playable::weaponConfigChanged();
 
-  setReactor(10);
-  setWeapon(10);
-  setEngine(15);
-
   this->bInit = false;
 
@@ -221,4 +217,7 @@
 //   loadHealth(100, 100, 0);
 //   loadElectronic(40, 50, .7, 3.0);
+  loadReactor(10);
+  loadWeapon(10);
+  loadEngine(15);
 
 //   this->loadModel("models/spaceships/fighter_redesign9.obj");
@@ -321,5 +320,5 @@
   State::getCamera()->setParent(this);
 
-  LoadParam(root, "setReactor", this, SpaceShip, setReactor)
+  LoadParam(root, "loadReactor", this, SpaceShip, loadReactor)
   .describe("set reactor output");
   LoadParam(root, "loadShield", this, WorldEntity, loadShield)
@@ -329,9 +328,9 @@
   LoadParam(root, "loadElectronic", this, WorldEntity, loadElectronic)
   .describe("set electronics parameters: current strenght , max strenght, threshhold value (0..1), regeneration rate");
-  LoadParam(root, "setEngine", this, SpaceShip, setEngine)
+  LoadParam(root, "loadEngine", this, SpaceShip, loadEngine)
   .describe("set base speed");
   LoadParam(root, "loadEnergyShare", this, SpaceShip, loadEnergyShare)
   .describe("set energy partitioning: shield, weapons, engine (sum should be 1)");
-  LoadParam(root, "setWeapon", this, SpaceShip, setWeapon)
+  LoadParam(root, "loadWeapon", this, SpaceShip, loadWeapon)
   .describe("set weapon regeneration");
 
@@ -444,5 +443,5 @@
 void SpaceShip::tick (float time)
 {
-/*
+
   if( !this->bInit)
   {
@@ -455,5 +454,5 @@
       {
         int slot = ws->getWeaponSlot();
-        int side = ws->getWeaponSide(); //FIXME / REMOVE: is not used// HACK needed for some weapons (left/right)
+//         int side = ws->getWeaponSide(); //FIXME / REMOVE: is not used// HACK needed for some weapons (left/right)
         this->getWeaponManager().setSlotPosition(slot, (*it).second->getCenter());
         this->getWeaponManager().setSlotDirection(slot, ws->getRelDir());
@@ -463,5 +462,5 @@
     }
   this->bInit = true;
-  }*/
+  }
 
   // Playable::tick(time);