Index: /branches/vs-enhencements/src/world_entities/space_ships/space_ship.cc
===================================================================
--- /branches/vs-enhencements/src/world_entities/space_ships/space_ship.cc	(revision 10673)
+++ /branches/vs-enhencements/src/world_entities/space_ships/space_ship.cc	(revision 10674)
@@ -165,12 +165,12 @@
   this->secWeaponMan.setSlotCount(6);
 
-//   this->weaponMan.createWeaponSlot(0, 3.270, 1.028, .155, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-//   this->weaponMan.createWeaponSlot(1, 3.270, 1.028, -.155, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-//   this->weaponMan.createWeaponSlot(2, 4.385, .063, .876, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-//   this->weaponMan.createWeaponSlot(3, 4.385, -.063, -.876, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-//   this->weaponMan.createWeaponSlot(4, 1.635, -.612, 2.691, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-//   this->weaponMan.createWeaponSlot(5, 1.536, -.612, -2.691, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-//   this->weaponMan.createWeaponSlot(6, 1.536, -.612, 3.254, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-//   this->weaponMan.createWeaponSlot(7, 1.536, -.612, -3.254, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(0, 3.270, 1.028, .155, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(1, 3.270, 1.028, -.155, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(2, 4.385, .063, .876, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(3, 4.385, -.063, -.876, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(4, 1.635, -.612, 2.691, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(5, 1.536, -.612, -2.691, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(6, 1.536, -.612, 3.254, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(7, 1.536, -.612, -3.254, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
 
 
@@ -213,8 +213,8 @@
   this->bInit = false;
 
-//   loadEnergyShare(.3,.3,.4);
-//   loadShield(80, 100, .2, 2);
-//   loadHealth(100, 100, 0);
-//   loadElectronic(40, 50, .7, 3.0);
+  loadEnergyShare(.3,.3,.4);
+  loadShield(80, 100, .2, 2);
+  loadHealth(100, 100);
+  loadElectronic(40, 50, .7, 3.0);
   loadReactor(10);
   loadWeapon(10);
@@ -444,23 +444,23 @@
 {
 
-  if( !this->bInit)
-  {
-    // now get slots from the mount points
-    std::map<int, MountPoint*>::iterator it = this->mountPointMap.begin();
-    for( ;it != this->mountPointMap.end(); it++)
-    {
-      WeaponSlot* ws = dynamic_cast<WeaponSlot*>((*it).second->getMount());
-      if( ws != NULL && ws->isA(WeaponSlot::staticClassID()))
-      {
-        int slot = ws->getWeaponSlot();
-//         int side = ws->getWeaponSide(); //FIXME / REMOVE: is not used// HACK needed for some weapons (left/right)
-        this->getWeaponManager().setSlotPosition(slot, (*it).second->getCenter());
-        this->getWeaponManager().setSlotDirection(slot, ws->getRelDir());
-//         PRINTF(0)("setting slot %i\n", slot);
-//         (*it).second->getCenter().debug();
-      }
-    }
-  this->bInit = true;
-  }
+//   if( !this->bInit)
+//   {
+//     // now get slots from the mount points
+//     std::map<int, MountPoint*>::iterator it = this->mountPointMap.begin();
+//     for( ;it != this->mountPointMap.end(); it++)
+//     {
+//       WeaponSlot* ws = dynamic_cast<WeaponSlot*>((*it).second->getMount());
+//       if( ws != NULL && ws->isA(WeaponSlot::staticClassID()))
+//       {
+//         int slot = ws->getWeaponSlot();
+// //         int side = ws->getWeaponSide(); //FIXME / REMOVE: is not used// HACK needed for some weapons (left/right)
+//         this->getWeaponManager().setSlotPosition(slot, (*it).second->getCenter());
+//         this->getWeaponManager().setSlotDirection(slot, ws->getRelDir());
+// //         PRINTF(0)("setting slot %i\n", slot);
+// //         (*it).second->getCenter().debug();
+//       }
+//     }
+//   this->bInit = true;
+//   }
 
   // Playable::tick(time);
Index: /branches/vs-enhencements/src/world_entities/world_entity.cc
===================================================================
--- /branches/vs-enhencements/src/world_entities/world_entity.cc	(revision 10673)
+++ /branches/vs-enhencements/src/world_entities/world_entity.cc	(revision 10674)
@@ -130,9 +130,15 @@
 
   // Delete the obbTree
-  if( this->obbTree != NULL)
+  if( this->obbTree)
     delete this->obbTree;
 
-  if (this->healthWidget != NULL)
+  if (this->healthWidget)
     delete this->healthWidget;
+
+  if(this->shieldWidget)
+    delete this->shieldWidget;
+
+  if( this->electronicWidget)
+    delete this->electronicWidget;
 
   this->unsubscribeReactions();
@@ -809,8 +815,8 @@
     float retShield = this->shieldMax - this->shield;
     this->shield = this->shieldMax;
-    this->updateShieldWidget();
+//     this->updateShieldWidget();
     return retShield;
   }
-  this->updateShieldWidget();
+//   this->updateShieldWidget();
   return 0.0;
 }
@@ -827,9 +833,9 @@
   {
     float retShield = -this->shield;
-    this->updateShieldWidget();
+//     this->updateShieldWidget();
     this->bShieldActive = false;
     return retShield;
   }
-  this->updateShieldWidget();
+//   this->updateShieldWidget();
   return 0.0;
 }
@@ -863,5 +869,5 @@
   {
     this->shieldWidget = new OrxGui::GLGuiEnergyWidgetVertical();
-    this->updateHealthWidget();
+    this->updateShieldWidget();
   }
   else