Index: code/branches/AI_HS15/src/orxonox/controllers/AIController.cc
===================================================================
--- code/branches/AI_HS15/src/orxonox/controllers/AIController.cc	(revision 10676)
+++ code/branches/AI_HS15/src/orxonox/controllers/AIController.cc	(revision 10678)
Index: code/branches/AI_HS15/src/orxonox/controllers/AIController.h
===================================================================
--- code/branches/AI_HS15/src/orxonox/controllers/AIController.h	(revision 10676)
+++ code/branches/AI_HS15/src/orxonox/controllers/AIController.h	(revision 10678)
Index: code/branches/AI_HS15/src/orxonox/controllers/ArtificialController.cc
===================================================================
--- code/branches/AI_HS15/src/orxonox/controllers/ArtificialController.cc	(revision 10676)
+++ code/branches/AI_HS15/src/orxonox/controllers/ArtificialController.cc	(revision 10678)
Index: code/branches/AI_HS15/src/orxonox/controllers/ArtificialController.h
===================================================================
--- code/branches/AI_HS15/src/orxonox/controllers/ArtificialController.h	(revision 10676)
+++ code/branches/AI_HS15/src/orxonox/controllers/ArtificialController.h	(revision 10678)
Index: code/branches/AI_HS15/src/orxonox/controllers/CMakeLists.txt
===================================================================
--- code/branches/AI_HS15/src/orxonox/controllers/CMakeLists.txt	(revision 10676)
+++ code/branches/AI_HS15/src/orxonox/controllers/CMakeLists.txt	(revision 10678)
@@ -11,3 +11,8 @@
   FormationController.cc
   ControllerDirector.cc
+  FleetController.cc
+  DivisionController.cc
+  SectionController.cc
+  LeaderController.cc
+  WingmanController.cc
 )
Index: code/branches/AI_HS15/src/orxonox/controllers/DivisionController.cc
===================================================================
--- code/branches/AI_HS15/src/orxonox/controllers/DivisionController.cc	(revision 10678)
+++ code/branches/AI_HS15/src/orxonox/controllers/DivisionController.cc	(revision 10678)
@@ -0,0 +1,60 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      Dominik Solenicki
+ *
+ */
+
+#include "DivisionController.h"
+
+
+namespace orxonox
+{
+
+    RegisterClass(DivisionController);
+
+    DivisionController::DivisionController(Context* context) : FleetController(context)
+    {
+        RegisterObject(DivisionController);
+    }
+
+    DivisionController::~DivisionController()
+    {
+        if (this->isInitialized())
+        {
+           
+        }
+    }
+
+    /*void DivisionController::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(DivisionController, XMLPort, xmlelement, mode);
+
+        //XMLPortParam(DivisionController, "target_", setTarget, getTarget, xmlelement, mode).defaultValues(100.0f);
+    }*/
+
+    
+   
+
+}
Index: code/branches/AI_HS15/src/orxonox/controllers/DivisionController.h
===================================================================
--- code/branches/AI_HS15/src/orxonox/controllers/DivisionController.h	(revision 10678)
+++ code/branches/AI_HS15/src/orxonox/controllers/DivisionController.h	(revision 10678)
@@ -0,0 +1,55 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      Dominik Solenicki
+ *
+ */
+
+#ifndef _DivisionController_H__
+#define _DivisionController_H__
+
+#include "controllers/FleetController.h"
+
+
+namespace orxonox
+{
+    class _OrxonoxExport DivisionController : public FleetController
+    {
+        public:
+        DivisionController(Context* context);
+        virtual ~DivisionController();
+
+        //virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+
+
+
+
+        protected:
+
+    
+        private:
+    };
+}
+
+#endif /* _DivisionController_H__ */
Index: code/branches/AI_HS15/src/orxonox/controllers/FleetController.cc
===================================================================
--- code/branches/AI_HS15/src/orxonox/controllers/FleetController.cc	(revision 10678)
+++ code/branches/AI_HS15/src/orxonox/controllers/FleetController.cc	(revision 10678)
@@ -0,0 +1,69 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      Dominik Solenicki
+ *
+ */
+
+#include "FleetController.h"
+
+
+namespace orxonox
+{
+
+    RegisterClass(FleetController);
+
+    FleetController::FleetController(Context* context) : Controller(context)
+    {
+        RegisterObject(FleetController);
+        
+        this->gameGoal_ = DOMINATE;
+        this->goalPosition_ = NULL;
+        this->goalTarget_ = NULL;
+        this->goalProtect_ = NULL;
+    }
+
+    FleetController::~FleetController()
+    {
+        if (this->isInitialized())
+        {
+           
+        }
+    }
+   
+    void FleetController::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(FleetController, XMLPort, xmlelement, mode);
+
+        //XMLPortObject(FleetController, GameGoal, "gameGoal", setGameGoal, getGameGoal, xmlelement, mode).defaultValues(DOMINATE);
+        //XMLPortParam(FleetController, "goalPosition", setGoalPosition, getGoalPosition, xmlelement, mode).defaultValues(NULL);
+        //XMLPortParam(FleetController, "goalTarget", setGoalTarget, getGoalTarget, xmlelement, mode).defaultValues(NULL);
+        //XMLPortParam(FleetController, "goalProtect", setGoalProtect, getGoalProtect, xmlelement, mode).defaultValues(NULL);
+
+    }
+
+    
+   
+
+}
Index: code/branches/AI_HS15/src/orxonox/controllers/FleetController.h
===================================================================
--- code/branches/AI_HS15/src/orxonox/controllers/FleetController.h	(revision 10678)
+++ code/branches/AI_HS15/src/orxonox/controllers/FleetController.h	(revision 10678)
@@ -0,0 +1,116 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      Dominik Solenicki
+ *
+ */
+
+#ifndef _FleetController_H__
+#define _FleetController_H__
+
+#include "controllers/Controller.h"
+
+#include "OrxonoxPrereqs.h"
+#include "core/class/Super.h"
+#include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
+#include "core/command/ConsoleCommandIncludes.h"
+#include "core/command/Executor.h"
+
+#include <vector>
+#include "util/Math.h"
+#include <climits>
+
+#include "tools/Timer.h"
+#include "tools/interfaces/Tickable.h"
+
+#include "worldentities/ControllableEntity.h"
+#include "worldentities/pawns/SpaceShip.h"
+#include "worldentities/pawns/Pawn.h"
+#include "worldentities/pawns/TeamBaseMatchBase.h"
+
+#include "gametypes/TeamDeathmatch.h"
+#include "gametypes/Dynamicmatch.h"
+#include "gametypes/Mission.h"
+#include "gametypes/Gametype.h"
+
+#include "controllers/WaypointPatrolController.h"
+#include "controllers/NewHumanController.h"
+#include "controllers/DroneController.h"
+
+
+namespace orxonox
+{   
+
+    class _OrxonoxExport FleetController : public Controller
+    {
+        public:
+        FleetController(Context* context);
+        virtual ~FleetController();
+
+
+        virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+
+        //gameGoal_ is to be set in XML
+        //DOMINATE is default, makes AI want to be the only team alive
+        //MOVE makes a fleet move to a set absolute position (set in variable goalPosition_)
+        //DESTROY makes a fleet destroy a target (set in variable goalTarget_)
+        //PROTECT makes a fleet protect a target (set in variable goalProtect_)
+        enum GameGoal {DOMINATE, MOVE, DESTROY, PROTECT};
+        
+        /*void setGameGoal(GameGoal gameGoal)
+           { this->gameGoal_ = gameGoal; }
+        GameGoal getGameGoal() const
+           { return this->gameGoal_; }
+        
+        void setGoalPosition(Vector3* goalPosition)
+           { this->goalPosition_ = goalPosition; }
+        Vector3* getGoalPosition() const
+           { return this->goalPosition_; }
+        
+        void setGoalTarget(Pawn* goalTarget)
+           { this->goalTarget_ = goalTarget; }
+        Pawn* getGoalTarget() const
+           { return this->goalTarget_; }
+        
+        void setGoalProtect(Pawn* goalProtect)
+           { this->goalProtect_ = goalProtect; }
+        Pawn* getGoalProtect() const
+           { return this->goalProtect_; }*/
+
+
+
+        protected:
+
+            
+            GameGoal gameGoal_;
+            Vector3* goalPosition_;
+            WeakPtr<Pawn> goalTarget_;
+            WeakPtr<Pawn> goalProtect_;
+
+
+    };
+}
+
+#endif /* _FleetController_H__ */
Index: code/branches/AI_HS15/src/orxonox/controllers/FormationController.cc
===================================================================
--- code/branches/AI_HS15/src/orxonox/controllers/FormationController.cc	(revision 10676)
+++ code/branches/AI_HS15/src/orxonox/controllers/FormationController.cc	(revision 10678)
Index: code/branches/AI_HS15/src/orxonox/controllers/FormationController.h
===================================================================
--- code/branches/AI_HS15/src/orxonox/controllers/FormationController.h	(revision 10676)
+++ code/branches/AI_HS15/src/orxonox/controllers/FormationController.h	(revision 10678)
@@ -185,3 +185,2 @@
 #endif /* _FormationController_h__ */
 
-
Index: code/branches/AI_HS15/src/orxonox/controllers/LeaderController.cc
===================================================================
--- code/branches/AI_HS15/src/orxonox/controllers/LeaderController.cc	(revision 10678)
+++ code/branches/AI_HS15/src/orxonox/controllers/LeaderController.cc	(revision 10678)
@@ -0,0 +1,66 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      Dominik Solenicki
+ *
+ */
+
+#include "LeaderController.h"
+
+
+
+namespace orxonox
+{
+    const float LeaderController::ACTION_INTERVAL = 1.0f;
+
+    RegisterClass(LeaderController);
+
+    LeaderController::LeaderController(Context* context) : SectionController(context)
+    {
+        RegisterObject(LeaderController);
+        this->actionTimer_.setTimer(ACTION_INTERVAL, true, createExecutor(createFunctor(&LeaderController::action, this)));
+    }
+
+    LeaderController::~LeaderController()
+    {
+    }
+
+    void LeaderController::action()
+    {
+        
+    }
+
+    void LeaderController::tick(float dt)
+    {
+
+      
+        SUPER(LeaderController, tick, dt);
+    }
+//**********************************************NEW
+    void LeaderController::defaultBehaviour(float maxrand)
+    {  
+       
+    }
+
+}
Index: code/branches/AI_HS15/src/orxonox/controllers/LeaderController.h
===================================================================
--- code/branches/AI_HS15/src/orxonox/controllers/LeaderController.h	(revision 10678)
+++ code/branches/AI_HS15/src/orxonox/controllers/LeaderController.h	(revision 10678)
@@ -0,0 +1,57 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _LeaderController_H__
+#define _LeaderController_H__
+
+#include "SectionController.h"
+
+
+namespace orxonox
+{
+    class _OrxonoxExport LeaderController : public SectionController, public Tickable
+    {
+        public:
+        LeaderController(Context* context);
+        virtual ~LeaderController();
+
+        virtual void tick(float dt); //<! Carrying out the targets set in action().
+
+        protected:
+        virtual void action(); //<! action() is called in regular intervals managing the bot's behaviour ~ setting targets.
+        void defaultBehaviour(float maxrand); //<! Helper function for code reusage. Some concrete commands for a bot.
+
+        private:
+        static const float ACTION_INTERVAL;
+
+        Timer actionTimer_; //<! Regularly calls action().
+           
+    };
+}
+
+#endif /* _LeaderController_H__ */
Index: code/branches/AI_HS15/src/orxonox/controllers/SectionController.cc
===================================================================
--- code/branches/AI_HS15/src/orxonox/controllers/SectionController.cc	(revision 10678)
+++ code/branches/AI_HS15/src/orxonox/controllers/SectionController.cc	(revision 10678)
@@ -0,0 +1,59 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      Dominik Solenicki
+ *
+ */
+
+#include "SectionController.h"
+
+namespace orxonox
+{
+
+    RegisterClass(SectionController);
+
+    SectionController::SectionController(Context* context) : DivisionController(context)
+    {
+        RegisterObject(SectionController);
+    }
+
+    SectionController::~SectionController()
+    {
+        if (this->isInitialized())
+        {
+           
+        }
+    }
+
+    /*void SectionController::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(SectionController, XMLPort, xmlelement, mode);
+
+        //XMLPortParam(SectionController, "target_", setTarget, getTarget, xmlelement, mode).defaultValues(100.0f);
+    }*/
+
+    
+   
+
+}
Index: code/branches/AI_HS15/src/orxonox/controllers/SectionController.h
===================================================================
--- code/branches/AI_HS15/src/orxonox/controllers/SectionController.h	(revision 10678)
+++ code/branches/AI_HS15/src/orxonox/controllers/SectionController.h	(revision 10678)
@@ -0,0 +1,55 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      Dominik Solenicki
+ *
+ */
+
+#ifndef _SectionController_H__
+#define _SectionController_H__
+
+#include "controllers/DivisionController.h"
+
+
+namespace orxonox
+{
+    class _OrxonoxExport SectionController : public DivisionController
+    {
+        public:
+        SectionController(Context* context);
+        virtual ~SectionController();
+
+        //virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+
+
+
+
+        protected:
+
+    
+        private:
+    };
+}
+
+#endif /* _SectionController_H__ */
Index: code/branches/AI_HS15/src/orxonox/controllers/WingmanController.cc
===================================================================
--- code/branches/AI_HS15/src/orxonox/controllers/WingmanController.cc	(revision 10678)
+++ code/branches/AI_HS15/src/orxonox/controllers/WingmanController.cc	(revision 10678)
@@ -0,0 +1,72 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      Dominik Solenicki
+ *
+ */
+
+#include "WingmanController.h"
+
+
+namespace orxonox
+{
+    const float WingmanController::ACTION_INTERVAL = 1.0f;
+
+    RegisterClass(WingmanController);
+
+    WingmanController::WingmanController(Context* context) : SectionController(context)
+    {
+        RegisterObject(WingmanController);
+        this->actionTimer_.setTimer(ACTION_INTERVAL, true, createExecutor(createFunctor(&WingmanController::action, this)));
+    }
+
+    WingmanController::~WingmanController()
+    {
+    }
+
+   /* void WingmanController::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(WingmanController, XMLPort, xmlelement, mode);
+
+        XMLPortParam(WingmanController, "accuracy", setAccuracy, getAccuracy, xmlelement, mode).defaultValues(100.0f);
+        XMLPortObject(WingmanController, WorldEntity, "waypoints", addWaypoint, getWaypoint,  xmlelement, mode);
+    }*/
+    void WingmanController::action()
+    {
+        
+    }
+
+    void WingmanController::tick(float dt)
+    {
+
+      
+        SUPER(WingmanController, tick, dt);
+    }
+//**********************************************NEW
+    void WingmanController::defaultBehaviour(float maxrand)
+    {  
+       
+    }
+
+}
Index: code/branches/AI_HS15/src/orxonox/controllers/WingmanController.h
===================================================================
--- code/branches/AI_HS15/src/orxonox/controllers/WingmanController.h	(revision 10678)
+++ code/branches/AI_HS15/src/orxonox/controllers/WingmanController.h	(revision 10678)
@@ -0,0 +1,59 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _WingmanController_H__
+#define _WingmanController_H__
+
+
+#include "SectionController.h"
+
+
+namespace orxonox
+{
+    class _OrxonoxExport WingmanController : public SectionController, public Tickable
+    {
+        public:
+            WingmanController(Context* context);
+            virtual ~WingmanController();
+            //virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void tick(float dt); //<! Carrying out the targets set in action().
+
+        protected:
+            virtual void action(); //<! action() is called in regular intervals managing the bot's behaviour ~ setting targets.
+            void defaultBehaviour(float maxrand); //<! Helper function for code reusage. Some concrete commands for a bot.
+
+
+        private:
+            static const float ACTION_INTERVAL;
+
+            Timer actionTimer_; //<! Regularly calls action().
+           
+    };
+}
+
+#endif /* _WingmanController_H__ */