Index: code/branches/campaignHS15/data/levels/Campaign1.oxw
===================================================================
--- code/branches/campaignHS15/data/levels/Campaign1.oxw	(revision 10679)
+++ code/branches/campaignHS15/data/levels/Campaign1.oxw	(revision 10680)
@@ -121,5 +121,5 @@
         <events>
             <trigger>
-                <SpawnPoint team=1 position="-50,0,0" lookat="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff2 />
+                <SpawnPoint team=1 position="0,-50,0" lookat="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff2 />
             </trigger>
         </events>
@@ -152,7 +152,8 @@
     <!--STRUCTURE -->
 
-    <StaticEntity position="-2500,0,1800" direction="0,-1,0" collisionType=static mass=100000 friction=0.01 >
+    <!-- A, Coordinates are approx. (cos(29pi/16), sin(29pi/16), 0)*3000 -->
+    <StaticEntity position="2494,-1667,0" direction="0,-1,0" collisionType=static mass=100000 friction=0.01 >
         <attached>
-            <Model position="0,0,0" mesh="cube.mesh" scale3D="10,10,10" />
+            <Model position="0,0,0" mesh="cube.mesh" scale3D="40,40,40" />
         </attached>
         <collisionShapes>
@@ -161,7 +162,8 @@
     </StaticEntity>
 
-    <StaticEntity position="-2500,0,-1800" direction="0,-1,0" collisionType=static mass=100000 friction=0.01 >
+    <!-- B, Coordinates are approx. (-cos(29pi/16), sin(29pi/16), 0)*3000 -->
+    <StaticEntity position="-2494,-1667,0" direction="0,-1,0" collisionType=static mass=100000 friction=0.01 >
         <attached>
-            <Model position="0,0,0" mesh="cube.mesh" scale3D="10,10,10" />
+            <Model position="0,0,0" mesh="cube.mesh" scale3D="40,40,40" />
         </attached>
         <collisionShapes>
@@ -172,4 +174,5 @@
     <!--ELEMENTS -->
 
+    <!-- Enemies -->
     <?lua
     max = 5
@@ -179,10 +182,10 @@
     y = math.sin(math.pi/8*(i+1))*1500
     ?>
-    <SpaceShip position="<?lua print(y)?>,<?lua print(math.pow(-1,i)*250) ?>,<?lua print(x)?>" lookat="0,0,0" team=2>
+    <SpaceShip position="<?lua print(x)?>,<?lua print(y)?>,<?lua print(math.pow(-1,i)*250) ?>" lookat="0,0,0" team=2>
         <templates>
             <Template link="spaceshippirate" />
         </templates>
         <controller>
-            <WaypointPatrolController alertnessradius=600 team=1>
+            <WaypointPatrolController alertnessradius=50 team=1>
                 <waypoints>
                     <Attacher target="transporter" deletewithparent=false />
@@ -193,5 +196,6 @@
     <?lua end ?>
 
-    <SpaceShip position="-2500,0,1700" lookat="-2500,0,-1800" team=1 name="transporter">
+    <!-- Transporter, starting Point is near A, end Point near B, the circle parameters for the waypoints are: Center = (0, -887, 0), r = 2613 -->
+    <SpaceShip position="2450, -1667, 0" lookat="-2494, -1667, 0" team=1 name="transporter">
         <templates>
             <Template link="spaceshipTransporter" />
@@ -200,15 +204,31 @@
             <WaypointController accuracy=10>
                 <waypoints>
-                    <Model mesh="sphere.mesh" scale=100 position="-2500,0,1650" />
+                    <!-- A to B -->
                     <?lua
                     max = 5
                     for i = 1, max, 1
                     do
-                    x = math.cos(math.pi/8*(i+1))*3490
-                    y = -math.sin(math.pi/8*(i+1))*3490
+                    x = math.cos(math.pi*(i+1)/8)*2613
+                    y = -math.sin(math.pi*(i+1)/8)*2613-887
                     ?>
-                    <Model mesh="sphere.mesh" scale=100 position="<?lua print(y) ?>+490,0,<?lua print(x) ?>" />
+                    <Model mesh="sphere.mesh" scale=100 position="<?lua print(x) ?>,<?lua print(y) ?>,0" />
                     <?lua end ?>
-                    <Model mesh="sphere.mesh" scale=100 position="-2500,0,-1650" />
+
+                    <!-- Return Point -->
+                    <Model mesh="sphere.mesh" scale=100 position="-2450, -1667, 0" />
+
+                    <!-- B to A -->
+                    <?lua
+                    max = 5
+                    for i = 1, max, 1
+                    do
+                    x = math.cos(math.pi*(max+2-i)/8)*2613
+                    y = -math.sin(math.pi*(max+2-i)/8)*2613-887
+                    ?>
+                    <Model mesh="sphere.mesh" scale=100 position="<?lua print(x) ?>,<?lua print(y) ?>,0" />
+                    <?lua end ?>
+
+                    <!-- Start Point -->
+                    <Model mesh="sphere.mesh" scale=100 position="2450,-1667,0" />
                 </waypoints>
             </WaypointController>