Index: branches/vs-enhencements/src/world_entities/space_ships/space_ship.cc
===================================================================
--- branches/vs-enhencements/src/world_entities/space_ships/space_ship.cc	(revision 10686)
+++ branches/vs-enhencements/src/world_entities/space_ships/space_ship.cc	(revision 10687)
@@ -165,12 +165,12 @@
   this->secWeaponMan.setSlotCount(6);
 
-//   this->weaponMan.createWeaponSlot(0, 3.270, 1.028, .155, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-//   this->weaponMan.createWeaponSlot(1, 3.270, 1.028, -.155, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-//   this->weaponMan.createWeaponSlot(2, 4.385, .063, .876, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-//   this->weaponMan.createWeaponSlot(3, 4.385, -.063, -.876, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-//   this->weaponMan.createWeaponSlot(4, 1.635, -.612, 2.691, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-//   this->weaponMan.createWeaponSlot(5, 1.536, -.612, -2.691, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-//   this->weaponMan.createWeaponSlot(6, 1.536, -.612, 3.254, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-//   this->weaponMan.createWeaponSlot(7, 1.536, -.612, -3.254, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(0, 3.270, 1.028, .155, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(1, 3.270, 1.028, -.155, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(2, 4.385, .063, .876, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(3, 4.385, -.063, -.876, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(4, 1.635, -.612, 2.691, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(5, 1.536, -.612, -2.691, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(6, 1.536, -.612, 3.254, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->weaponMan.createWeaponSlot(7, 1.536, -.612, -3.254, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
 
 
@@ -211,5 +211,5 @@
   Playable::weaponConfigChanged();
 
-  this->bInit = false;
+//   this->bInit = false;
 
   loadEnergyShare(.3,.3,.4);
@@ -297,7 +297,7 @@
 
 
-  dynamic_cast<WorldEntity*>(this)->createHealthWidget();
-  dynamic_cast<WorldEntity*>(this)->createShieldWidget();
-  dynamic_cast<WorldEntity*>(this)->createElectronicWidget();
+  (this)->createHealthWidget();
+  (this)->createShieldWidget();
+  (this)->createElectronicWidget();
 
   if ( this->hasPlayer() ){
@@ -399,4 +399,19 @@
 void SpaceShip::postSpawn ()
 {
+//   std::map<int, MountPoint*>::iterator it = this->mountPointMap.begin();
+//   for( ;it != this->mountPointMap.end(); it++)
+//   {
+//     WeaponSlot* ws = dynamic_cast<WeaponSlot*>((*it).second->getMount());
+//     if( ws != NULL && ws->isA(WeaponSlot::staticClassID()))
+//     {
+//       int slot = ws->getWeaponSlot();
+// //        int side = ws->getWeaponSide(); //FIXME / REMOVE: is not used// HACK needed for some weapons (left/right)
+//       this->getWeaponManager().setSlotPosition(slot, (*it).second->getCenter());
+//     this->getWeaponManager().setSlotDirection(slot, ws->getRelDir());
+// //         PRINTF(0)("setting slot %i\n", slot);
+// //         (*it).second->getCenter().debug();
+//     }
+//   }
+
   if(this->hasPlayer())
     Playable::postSpawn();
@@ -445,4 +460,8 @@
 }
 
+
+
+
+
 /**
  *  the function called for each passing timeSnap
@@ -451,5 +470,5 @@
 void SpaceShip::tick (float time)
 {
-
+/*
   if( !this->bInit)
   {
@@ -470,5 +489,5 @@
     }
   this->bInit = true;
-  }
+  }*/
 
   // Playable::tick(time);
Index: branches/vs-enhencements/src/world_entities/space_ships/space_ship.h
===================================================================
--- branches/vs-enhencements/src/world_entities/space_ships/space_ship.h	(revision 10686)
+++ branches/vs-enhencements/src/world_entities/space_ships/space_ship.h	(revision 10687)
@@ -166,5 +166,5 @@
     bool                  bSecFire;           //!< second fire button pressed
 
-    bool                  bInit;              //!< set true, if MP have been loaded
+//    bool                  bInit;              //!< set true, if MP have been loaded
 
     /*
Index: branches/vs-enhencements/src/world_entities/weapons/weapon_slot.h
===================================================================
--- branches/vs-enhencements/src/world_entities/weapons/weapon_slot.h	(revision 10686)
+++ branches/vs-enhencements/src/world_entities/weapons/weapon_slot.h	(revision 10687)
@@ -9,5 +9,7 @@
 #include "p_node.h"
 #include "weapon.h"
-#include "weapon_manager.h"
+// #include "weapon_manager.h"
+
+#define    WM_MAX_CONFIGS          4              //!< The maximum number of predefined Configurations
 
 class Weapon;