Index: /code/branches/campaignHS15/data/levels/Campaign1.oxw
===================================================================
--- /code/branches/campaignHS15/data/levels/Campaign1.oxw	(revision 10689)
+++ /code/branches/campaignHS15/data/levels/Campaign1.oxw	(revision 10690)
@@ -27,4 +27,5 @@
 
     <?lua include("includes/notifications.oxi") ?>
+
     <NotificationQueueCEGUI
         name="narrative"
@@ -59,5 +60,5 @@
 
     <GlobalQuest id="quest1">
-        <QuestDescription title="Reach the Station!" description="" failMessage="" completeMessage="" />
+        <QuestDescription title="Reach the Station A!" description="" failMessage="" completeMessage="" />
         <hints>
             <QuestHint id="quest1hint1" />
@@ -290,5 +291,5 @@
     </SimpleNotification>
 
-    <SimpleNotification broadcast="true" message="yippie kai yay motherf*cker!">
+    <SimpleNotification broadcast="true" message="yippie ki yay motherf*cker!">
         <events>
             <trigger>
@@ -320,33 +321,51 @@
     <!--STRUCTURE -->
 
+    <!-- (Temporary) Template for stations. Used to define common features of all Stations. -->
+    <Template name="station">
+        <Pawn position="2800,0,0" health=1000 mass=10000 collisionType=dynamic friction=0.01>
+          <attached>
+            <Model mesh="HydroHarvester.mesh" position="0,0,0" scale=50 />
+          </attached>
+          <collisionShapes>
+            <BoxCollisionShape  position="-560,0,0" halfExtents="115,100,245" /><!-- Three lower boxes -->
+            <BoxCollisionShape  position="290,0,-480" halfExtents="115,100,245" yaw=-120 />
+            <BoxCollisionShape  position="290,0,480" halfExtents="115,100,245" yaw=-240 />
+            <BoxCollisionShape  position="-280,0,0" halfExtents="163,50,50" /><!-- Three lower connections -->
+            <BoxCollisionShape  position="140,0,-240" halfExtents="163,50,50" yaw=-120 />
+            <BoxCollisionShape  position="140,0,240" halfExtents="163,50,50" yaw=-240 />
+            <BoxCollisionShape  position="0,530,0" halfExtents="172,52,298" /><!-- Upper Tower -->
+            <BoxCollisionShape  position="0,530,0" halfExtents="172,52,298" yaw=-120 />
+            <BoxCollisionShape  position="0,530,0" halfExtents="172,52,298" yaw=-240 />
+            <BoxCollisionShape  position="0,400,0" halfExtents="43,110,26" yaw=-30 /><!-- Middle one-->
+            <BoxCollisionShape  position="-200,100,0" halfExtents="26,50,43" /><!--Three lower legs -->
+            <BoxCollisionShape  position="100,100,-173" halfExtents="43,50,26" yaw=-30 />
+            <BoxCollisionShape  position="100,100,-173" halfExtents="43,50,26" yaw=30 />
+            <BoxCollisionShape  position="-100,264,0" halfExtents="26,105,43" roll=-49 /><!--Three upper legs -->
+            <BoxCollisionShape  position="50,264,-87" halfExtents="26,105,43" roll=-49 yaw=-120 />
+            <BoxCollisionShape  position="50,264,87" halfExtents="26,105,43" roll=-49 yaw=-240 />
+          </collisionShapes>
+      </Pawn>
+    </Template>
+
     <!-- A, Coordinates are approx. (cos(29pi/16), sin(29pi/16), 0)*3000 -->
-    <StaticEntity name="statA" position="2494,-1667,0" direction="0,-1,0" collisionType=static mass=100000 friction=0.01>
-        <attached>
-            <Model position="0,0,0" mesh="cube.mesh" scale3D="40,40,40" />
-        </attached>
-        <collisionShapes>
-            <BoxCollisionShape position="0,0,0" halfExtents="10,10,10" />
-        </collisionShapes>
-    </StaticEntity>
+    <Pawn name="statA" radarname="Station A" position="2494,-1667,0" direction="0,1,0">
+        <templates>
+            <Template link="station" />
+        </templates>
+    </Pawn>
 
     <!-- B, Coordinates are approx. (-cos(29pi/16), sin(29pi/16), 0)*3000 -->
-    <StaticEntity name="statB" position="-2494,-1667,0" direction="0,-1,0" collisionType=static mass=100000 friction=0.01>
-        <attached>
-            <Model position="0,0,0" mesh="cube.mesh" scale3D="40,40,40" />
-        </attached>
-        <collisionShapes>
-            <BoxCollisionShape position="0,0,0" halfExtents="10,10,10" />
-        </collisionShapes>
-    </StaticEntity>
+    <Pawn name="statB" radarname="Station B" position="-2494,-1667,0" direction="0,1,0">
+        <templates>
+            <Template link="station" />
+        </templates>
+    </Pawn>
 
     <!-- C -->
-    <StaticEntity name="statC" position="0,-1400,0" direction="0,-1,0" collisionType=static mass=100000 friction=0.01>
-        <attached>
-            <Model position="0,0,0" mesh="cube.mesh" scale3D="40,40,40" />
-        </attached>
-        <collisionShapes>
-            <BoxCollisionShape position="0,0,0" halfExtents="10,10,10" />
-        </collisionShapes>
-    </StaticEntity>
+    <Pawn name="statC" radarname="Station C" position="0,-1400,0" direction="0,1,0">
+        <templates>
+            <Template link="station" />
+        </templates>
+    </Pawn>
 
     <!--ELEMENTS -->
@@ -413,9 +432,9 @@
                     y = -math.sin(math.pi*(i+1)/8)*2613-887
                     ?>
-                    <Model mesh="sphere.mesh" scale=100 position="<?lua print(x) ?>,<?lua print(y) ?>,0" />
+                    <Billboard position="<?lua print(x) ?>,<?lua print(y) ?>,0" amplitude=1 material="Flares/lensflare" colour="1,1,0.05"/>
                     <?lua end ?>
 
                     <!-- Return Point -->
-                    <Model mesh="sphere.mesh" scale=100 position="-2450, -1667, 0" />
+                    <Billboard position="-2450, -1667, 0" amplitude=1 material="Flares/lensflare" colour="1,1,0.05"/>
 
                     <!-- B to A -->
@@ -427,9 +446,9 @@
                     y = -math.sin(math.pi*(max+2-i)/8)*2613-887
                     ?>
-                    <Model mesh="sphere.mesh" scale=100 position="<?lua print(x) ?>,<?lua print(y) ?>,0" />
+                    <Billboard position="<?lua print(x) ?>,<?lua print(y) ?>,0" amplitude=1 material="Flares/lensflare" colour="1,1,0.05"/>
                     <?lua end ?>
 
                     <!-- Start Point -->
-                    <Model mesh="sphere.mesh" scale=100 position="2450,-1667,0" />
+                    <Billboard position="2450,-1667,0" amplitude=1 material="Flares/lensflare" colour="1,1,0.05"/>
                 </waypoints>
             </WaypointController>